#include <cstdlib>
#include <cmath>
#include <GL/glut.h>

#define QUIT 0
#define ImageWidth 300
#define ImageHeight 300

GLubyte Image[ImageWidth][ImageHeight][3];

void menu (int mode)
{ 
  switch(mode)
  { 
    case QUIT: exit(0);
  }
}

void init()
{ 
  int x,y;

  for (y = -150; y < 150; y++) 
  {
    for (x = -150; x < 150; x++) 
    {
      Image[150+y][150+x][0] = (GLubyte) floor(2.55*(y+150)/3.0);
      Image[150+y][150+x][1] = (GLubyte) floor(2.55*(y+150)/3.0);
      Image[150+y][150+x][2] = (GLubyte) floor(2.55*(y+150)/3.0);
    }
  }
}

void draw ()
{ 
  glClear( GL_COLOR_BUFFER_BIT );

  glRasterPos2i(0,0);
  glDrawPixels(ImageWidth,ImageHeight,GL_RGB,GL_UNSIGNED_BYTE,Image);
}

void reshape(int iw, int ih)
{  
   glViewport(0, 0, (GLint)iw, (GLint)ih);
   glMatrixMode(GL_PROJECTION);
   glLoadIdentity();
   gluOrtho2D(0.0,(GLfloat)iw,0.0,(GLfloat)ih);
   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity();
}

int 
main(int argc, char **argv)
{ 
  glutInit(&argc, argv);
  glutInitDisplayMode(GLUT_RGB | GLUT_SINGLE);
  glutInitWindowSize(300,300);
  glutInitWindowPosition(100,100);
  glutCreateWindow(argv[0]);
  glutDisplayFunc(draw);
  glutReshapeFunc(reshape); 
  glutCreateMenu(menu);
  glutAddMenuEntry("Quit",QUIT);
  glutAttachMenu(GLUT_RIGHT_BUTTON);
  init();
  glutMainLoop();
  return 0;
}
